#include"256col.c"
#include<math.h>
#define pi 3.14159265
#define rat 0.9

static unsigned char V[240][200];

void line(int x1,int y1,int x2,int y2,int col)
{int dx,dy,x,y,a,b;
float k;
dx=x2-x1;
dy=y2-y1;
if(!dx)
{
if(dy>0) for(y=y1;y<=y2;y++) {if(inscr(x1,y))V[x1][y]=col;}
else     for(y=y1;y>=y2;y--) {if(inscr(x1,y))V[x1][y]=col;}
}
else
{
if(!dy)
{
if(dx>0) for(x=x1;x<=x2;x++) {if(inscr(x,y1))V[x][y1]=col;}
else     for(x=x1;x>=x2;x--) {if(inscr(x,y1))V[x][y1]=col;}
}
else
{
if(abs(dx)>abs(dy))
 {k=(float)dy/(float)dx;
 if(dx>0) for(x=0;x<=dx;x++) {
                             a=x+x1;
                             b=x*k+0.5+y1;
                             if(inscr(a,b))V[a][b]=col;
                             }
 else     for(x=0;x>=dx;x--) {
                             a=x+x1;
                             b=x*k+0.5+y1;
                             if(inscr(a,b))V[a][b]=col;
                             }
 }
else
 {k=(float)dx/(float)dy;
 if(dy>0) for(y=0;y<=dy;y++) {
                             a=y*k+0.5+x1;
                             b=y+y1;
                             if(inscr(a,b))V[a][b]=col;
                             }
 else     for(y=0;y>=dy;y--) {
                             a=y*k+0.5+x1;
                             b=y+y1;
                             if(inscr(a,b))V[a][b]=col;
                             }
 }
}
}
}

void circle(int x,int y,int r,int col)
{float t,dt,tm;
 int x1,x2,y1,y2;
 if(r<=0)V[x][y]=col;
 else
 {
 x1=x+r;
 y1=y;
 dt=pi/8;
 tm=2*pi+0.01;
 for(t=dt;t<=tm;t+=dt)
 {x2=(int)(r*cos(t))+x;
  y2=(int)(r*rat*sin(t))+y;
  line(x1,y1,x2,y2,col);
  line(x1+1,y1,x2+1,y2,col);
  line(x1+1,y1+1,x2+1,y2+1,col);
  line(x1+1,y1-1,x2+1,y2-1,col);
   x1=x2;
 y1=y2;
  }
  }
}

void tri(int x1,int y1,int x2,int y2,int x3,int y3,int col)
{int t,dx,dy,y,lo,hi,f1,f2,f3;
 float k1,k2,k3;
 if(y2<y1){t=y1;y1=y2;y2=t;t=x1;x1=x2;x2=t;}
 if(y3<y1){t=y1;y1=y3;y3=t;t=x1;x1=x3;x3=t;}
 if(y3<y2){t=y3;y3=y2;y2=t;t=x3;x3=x2;x2=t;}
 dx=x2-x1;
 dy=y2-y1;
 if(!dx){k1=0;f1=-2;}
 else if(!dy){k1=0;f1=-1;}
 else {k1=(float)dx/dy;f1=1;}
 dx=x3-x2;
 dy=y3-y2;
 if(!dx){k2=0;f2=-2;}
 else if(!dy){k2=0;f2=-1;}
 else {k2=(float)dx/dy;f2=1;}
 dx=x3-x1;
 dy=y3-y1;
 if(!dx){k3=0;f3=-2;}
 else if(!dy){k3=0;f3=-1;}
 else {k3=(float)dx/dy;f3=1;}
 for(y=y1;y<=y2;y++)
  {
  switch(f1)
   {
   case -1:lo=x1;hi=x2;break;
   case -2:lo=x1;break;
   case 1:lo=k1*(y-y1)+x1;
   }
  switch(f3)
   {
   case -1:lo=x1;hi=x3;break;
   case -2:hi=x3;break;
   case 1:hi=k3*(y-y3)+x3;
   }
  if(hi<lo){t=hi;hi=lo;lo=t;}
  line(lo,y,hi,y,col);
  }
  for(y=y2;y<=y3;y++)
  {
  switch(f2)
   {
   case -1:lo=x2;hi=x3;break;
   case -2:lo=x2;break;
   case 1:lo=k2*(y-y2)+0.5+x2;
   }
  switch(f3)
   {
   case -1:lo=x1;hi=x3;break;
   case -2:hi=x3;break;
   case 1:hi=k3*(y-y3)+x3;
   }
  //if(hi<lo){t=hi;hi=lo;lo=t;}
  line(lo,y,hi,y,col);
  }
}


